Add and Update People
Identifies a person and assigns traits to them.
In most cases, you'll identify people with a userId or an anonymousId. But when you use Customer.io as a destination, you can pass an empty userId or anonymousId, and identify people by their email trait.
When you use our libraries, you'll typically only provide an ID and traits. The libraries fill in the rest of the payload automatically.
- enumX
- Strict - Mode const:1When set to
1, enables strict validation that returns proper HTTP error codes (400/401) for validation failures. When not set or set to any other value, the API operates in permissive mode, logging errors but returning HTTP 200. Learn morevalues- 1
- userType: string
Id requiredThe unique identifier for a person. This value should be unique across systems, so you recognize the same person in your sources and destinations.
- anonymousType: string
Id A unique substitute for a User ID in cases when you don’t have an absolutely unique identifier. Our libraries generate this value automatically to help you track people before they sign up, log in, provide their email, etc.
- context
A dictionary of context about a source call/event, like the user’s IP address or locale. Context is automatically collected by our source libraries.
- integrationsType: object
Contains a list of booleans indicating the integrations that are enabled (true) or disabled (false). By default, all integrations are enabled (returning an empty object). Set
"All": falseto reverse this behavior. - messageType: string
Id A unique identifier for a Data Pipelines call, ensuring that each individual event is unique. This is set by Customer.io
- originalType: stringFormat: date-time
Timestamp In general, you can use
timestamprather than this field if you want to back-date events. This is the timestamp on the client device you invoke a call or the timestamp value you manually passed in a server-side library call. - sentType: stringFormat: date-time
At The ISO-8601 timestamp when a library sends an event to Data Pipelines.
- timestampType: stringFormat: date-time
The ISO-8601 timestamp when the event originally took place. This is mostly useful when you backfill past events. If you're not backfilling data, you can leave this field empty and we'll use the current time or server time.
- traitsType: object
Additional properties that you know about a person. We've listed some common/reserved traits below, but you can add any traits that you might use in another system.
- 200
A successful request returns an empty object response.
curl https://cdp.customer.io/v1/identify \
--request POST \
--header 'X-Strict-Mode: 1' \
--header 'Content-Type: application/json' \
--header 'Authorization: Basic username:password' \
--data '{
"type": "identify",
"traits": {
"name": "Cool Person",
"email": "cool.person@example.com",
"likes_baseball": true,
"games_attended": 5
},
"userId": "97980cfea0067"
}'
A successful request returns an empty object response.